//
//  DiaryDocument.m
//  Vermont Recipes 2.0.0
//
//  Created by Bill Cheeseman on 2009-06-03.
//  Copyright 2000-2009 Bill Cheeseman. All rights reserved.
//
//  CREATED IN RECIPE 3

#import "DiaryDocument.h"
#import "DiaryWindowController.h" // ADDED IN RECIPE 3


@implementation DiaryDocument

- (void)setDiaryDocTextStorage:(NSTextStorage *)textStorage { // ADDED IN RECIPE 3
	if (diaryDocTextStorage != textStorage) {
		[diaryDocTextStorage release];
		diaryDocTextStorage = [textStorage retain];
	}
}

- (NSTextStorage *)diaryDocTextStorage { // ADDED IN RECIPE 3
	return [[diaryDocTextStorage retain] autorelease];
}

- (void)makeWindowControllers { // ADDED IN RECIPE 3
	DiaryWindowController *controller = [[DiaryWindowController alloc] init];
	[self addWindowController:controller];
	[controller release];
}

/* DELETED IN RECIPE 3
- (NSString *)windowNibName {
    // Implement this to return a nib to load OR implement -makeWindowControllers to manually create your controllers.
    return @"DiaryDocument";
}
*/

- (NSData *)dataOfType:(NSString *)typeName error:(NSError **)outError { // ADDED IN RECIPE 3
    NSRange range = NSMakeRange(0, [[self diaryDocTextStorage] length]);
    NSData *data = [[self diaryDocTextStorage] RTFFromRange:range documentAttributes:nil];
    if ((data == nil) && (outError != NULL)) {
        *outError = [NSError errorWithDomain:NSCocoaErrorDomain code:NSFileWriteUnknownError userInfo:nil];
    }
    return data;
}

- (BOOL)readFromData:(NSData *)data ofType:(NSString *)typeName error:(NSError **)outError { // ADDED IN RECIPE 3
    NSTextStorage *textStorage = [[NSTextStorage alloc] initWithRTF:data documentAttributes:NULL];
    if ((textStorage == nil) && (outError != NULL)) {
        *outError = [NSError errorWithDomain:NSCocoaErrorDomain code:NSFileReadUnknownError userInfo:nil];
        return NO;
    }
    [self setDiaryDocTextStorage:textStorage];
    [textStorage release];
    return YES;
}

@end
