//
//  DiaryWindowController.m
//  Vermont Recipes 2.0.0
//
//  Created by Bill Cheeseman on 2009-06-05.
//  Copyright 2000-2009 Bill Cheeseman. All rights reserved.
//
//  CREATED IN RECIPE 3

#import "DiaryWindowController.h"
#import "DiaryDocument.h" // ADDED IN RECIPE 3

@implementation DiaryWindowController

- (id)init { // ADDED IN RECIPE 3
	if ((self = [self initWithWindowNibName:@"DiaryWindow"])) {
		// Insert any initialization code here.
	}
	return self;
}

- (NSTextView *)diaryView { // ADDED IN RECIPE 3
	return [[diaryView retain] autorelease];
}

- (NSTextView *)otherDiaryView { // ADDED IN RECIPE 3
	return [[otherDiaryView retain] autorelease];
}

- (void)textDidChange:(NSNotification *)notification { // ADDED IN RECIPE 3
	// Delegate method per NSText.
	if ([notification object] == [self diaryView]) {
		[[self otherDiaryView] setNeedsDisplayInRect:[[self otherDiaryView] visibleRect] avoidAdditionalLayout:NO];
	} else {
		[[self diaryView] setNeedsDisplayInRect:[[self diaryView] visibleRect] avoidAdditionalLayout:NO];
	}
}

- (void)windowDidLoad { // ADDED IN RECIPE 3
	NSTextStorage *docTextStorage = [[self document] diaryDocTextStorage];
	if (docTextStorage == nil) {
		[[self document] setDiaryDocTextStorage:[[self diaryView] textStorage]];
	} else {
		[[[self diaryView] layoutManager] replaceTextStorage:docTextStorage];
	}	
	
	[[[self otherDiaryView] layoutManager] replaceTextStorage:[[self diaryView] textStorage]];
}

@end
