//
//  RecipesWindowController.m
//  Vermont Recipes 2.0.0
//
//  Created by Bill Cheeseman on 2009-05-24.
//  Copyright 2000-2009 Bill Cheeseman. All rights reserved.
//
//  CREATED IN RECIPE 1

#import "RecipesWindowController.h"


@implementation RecipesWindowController

- (void)splitView:(NSSplitView *)splitView resizeSubviewsWithOldSize:(NSSize)oldSize { // ADDED IN RECIPE 2
	// Delegate method per NSSplitView.
	if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_5) {
		NSView *rightPane = [[splitView subviews] objectAtIndex:1];
		NSRect rightFrame = [rightPane frame];
		rightFrame.size.width += [splitView frame].size.width - oldSize.width;
		[rightPane setFrame:rightFrame];
	}
	[splitView adjustSubviews];
}

- (BOOL)splitView:(NSSplitView *)splitView shouldAdjustSizeOfSubview:(NSView *)view { // ADDED IN RECIPE 2
	// Delegate method per NSSplitView; added in Mac OS X 10.6 Snow Leopard.
	if ([splitView isVertical] && (view == [[splitView subviews] objectAtIndex:0])) {
		return NO;
	}
	return YES;
}

- (void)windowDidLoad { // ADDED IN RECIPE 5
	// Splice drawer into responder chain.
    NSResponder *oldNextResponder = [self nextResponder];
    NSResponder *newNextResponder = [[[self window] drawers] objectAtIndex:0];
    [self setNextResponder:newNextResponder];
	[newNextResponder setNextResponder:oldNextResponder];
}

@end
