//
//  DiaryDocument.h
//  Vermont Recipes 2.0.0
//
//  Created by Bill Cheeseman on 2009-06-03.
//  Copyright 2000-2009 Bill Cheesseman. All rights reserved.
//
//  CREATED IN RECIPE 3

#import <Cocoa/Cocoa.h>


extern NSString *VRDidSaveDiaryDocumentNotification; // ADDED IN RECIPE 7
extern NSString *VRDidAutosaveDiaryDocumentNotification; // ADDED IN RECIPE 7

@interface DiaryDocument : NSDocument {
	NSTextStorage *diaryDocTextStorage; // ADDED IN RECIPE 3
	BOOL isRestoringAutosavedDocument; // ADDED IN RECIPE 7
	BOOL isRevertingToSavedDocument; // ADDED IN RECIPE 7
}

#pragma mark ACCESSOR METHODS

- (void)setDiaryDocTextStorage:(NSTextStorage *)textStorage; // ADDED IN RECIPE 3
- (NSTextStorage *)diaryDocTextStorage; // ADDED IN RECIPE 3

- (void)setIsRestoringAutosavedDocument:(BOOL)flag; // ADDED IN RECIPE 7
- (BOOL)isRestoringAutosavedDocument; // ADDED IN RECIPE 7

- (void)setIsRevertingToSavedDocument:(BOOL)flag; // ADDED IN RECIPE 7
- (BOOL)isRevertingToSavedDocument; // ADDED IN RECIPE 7

#pragma mark ENTRY AND TAG TITLES

- (NSString *)entryMarker; // ADDED IN RECIPE 4
- (NSString *)entryTitleForDate:(NSDate *)date; // ADDED IN RECIPE 4
- (NSString *)entryTitleInsertForDate:(NSDate *)date; // ADDED IN RECIPE 4

- (NSString *)tagMarker; // ADDED IN RECIPE 4
- (NSString *)tagTitle; // ADDED IN RECIPE 4
- (NSString *)tagTitleInsert; // ADDED IN RECIPE 4

- (NSUInteger)adjustedIndexIfMarkerAtIndex:(NSUInteger)index; // ADDED IN RECIPE 4
- (NSRange)rangeOfLineFromMarkerIndex:(NSUInteger)markerIndex; // ADDED IN RECIPE 4

- (NSRange)currentEntryTitleRangeForIndex:(NSUInteger)index; // ADDED IN RECIPE 4
- (NSRange)firstEntryTitleRange; // ADDED IN RECIPE 4
- (NSRange)lastEntryTitleRange; // ADDED IN RECIPE 4
- (NSRange)previousEntryTitleRangeForIndex:(NSUInteger)index; // ADDED IN RECIPE 4
- (NSRange)nextEntryTitleRangeForIndex:(NSUInteger)index; // ADDED IN RECIPE 4
- (NSRange)firstEntryTitleRangeAtOrAfterDate:(NSDate *)targetDate; // ADDED IN RECIPE 4
- (NSDate *)dateFromEntryTitleRange:(NSRange)range; // ADDED IN RECIPE 4

- (NSRange)currentEntryTagRangeForIndex:(NSUInteger)index; // ADDED IN RECIPE 4
- (NSArray *)foundTagRangeArrayForTag:(NSString *)tag; // ADDED IN RECIPE 4
- (NSRange)firstTagRange; // ADDED IN RECIPE 4
- (NSRange)nextTagRangeForIndex:(NSUInteger)index; // ADDED IN RECIPE 4

@end
