//
//  DiaryWindowController.h
//  Vermont Recipes 2.0.0

//  Created by Bill Cheeseman on 2009-06-05.
//  Copyright 2000-2009 Bill Cheeseman. All rights reserved.
//
//  CREATED IN RECIPE 3

#import <Cocoa/Cocoa.h>


extern NSString *VRDefaultDiaryWindowStandardSizeKey; // ADDED IN RECIPE 7
extern NSString *VRDiaryWindowAutosaveName; // ADDED IN RECIPE 7
extern NSString *VRDiarySplitViewAutosaveName; // ADDED IN RECIPE 7

@interface DiaryWindowController : NSWindowController <NSUserInterfaceValidations> { // EDITED IN RECIPE 4
	IBOutlet NSTextView *diaryView; // ADDED IN RECIPE 3
	IBOutlet NSTextView *otherDiaryView; // ADDED IN RECIPE 3
	IBOutlet NSDatePicker *datePicker; // ADDED IN RECIPE 4
	IBOutlet NSSearchField *searchField; // ADDED IN RECIPE 5
	IBOutlet NSSplitView *splitView; // ADDED IN RECIPE 7
}

#pragma mark ACCESSOR METHODS

- (NSTextView *)diaryView; // ADDED IN RECIPE 3
- (NSTextView *)otherDiaryView; // ADDED IN RECIPE 3
- (NSDatePicker *)datePicker; // ADDED IN RECIPE 4
- (NSSearchField *)searchField; // ADDED IN RECIPE 5
- (NSSplitView *)splitView; // ADDED IN RECIPE 7

#pragma mark ACTION METHODS

- (IBAction)addEntry:(id)sender; // ADDED IN RECIPE 4
- (IBAction)addTag:(id)sender; // ADDED IN RECIPE 4

- (IBAction)goToFirstEntry:(id)sender; // ADDED IN RECIPE 4
- (IBAction)goToLastEntry:(id)sneder; // ADDED IN RECIPE 4
- (IBAction)goToPreviousEntry:(id)sender; // ADDED IN RECIPE 4
- (IBAction)goToNextEntry:(id)sender; // ADDED IN RECIPE 4
- (IBAction)goToDatedEntry:(id)sender; // ADDED IN RECIPE 4
- (IBAction)findTag:(id)sender; // ADDED IN RECIPE 4

#pragma mark USER INTERFACE VALIDATION

- (void)updateWindow; // ADDED IN RECIPE 4
- (void)updateDatePickerValue; // ADDED IN RECIPE 4

#pragma mark UTILITY METHODS

- (NSTextView *)keyDiaryView; // ADDED IN RECIPE 4
- (NSUInteger)insertionPointIndex; // ADDED IN RECIPE 4

#pragma mark ALERTS

- (NSAlert *)alertDidRestoreAutosavedDiaryDocument; // ADDED IN RECIPE 7

@end


#pragma mark -

@protocol VRValidatedControl <NSValidatedUserInterfaceItem> // ADDED IN RECIPE 4
@required
- (void)validate;
@end


#pragma mark -

@protocol VRControlValidations // ADDED IN RECIPE 4
@optional
- (BOOL)validateControl:(id <VRValidatedControl>)item;
@end


#pragma mark -

@interface ValidatedDiaryButton : NSButton <VRValidatedControl> { // ADDED IN RECIPE 4
}
@end


#pragma mark -

@interface ValidatedDiaryDatePicker : NSDatePicker <VRValidatedControl> { // ADDED IN RECIPE 4
}
@end


#pragma mark -

@interface ValidatedDiarySearchField : NSSearchField <VRValidatedControl> { // ADDED IN RECIPE 4
}
@end
