//
//  VRDocumentController.h
//  Vermont Recipes 2.0.0
//
//  Created by Bill Cheeseman on 2009-06-06.
//  Copyright 2000-2009 Bill Cheeseman. All rights reserved.
//
//  CREATED IN RECIPE 3

#import <Cocoa/Cocoa.h>


extern NSString *VRDefaultDiaryDocumentAliasDataKey; // ADDED IN RECIPE 6
extern NSString *VRDidRestoreAutosavedDiaryDocumentNotification; // ADDED IN RECIPE 7

@interface VRDocumentController : NSDocumentController { // EDITED IN RECIPE 3
}

#pragma mark ACTION METHODS

- (IBAction)newDiaryDocument:(id)sender; // ADDED IN RECIPE 3
- (IBAction)openDiaryDocument:(id)sender; // ADDED IN RECIPE 6

#pragma mark UTILITY METHODS

- (NSDocument *)diaryDocument; // ADDED IN RECIPE 6

#pragma mark ALIAS/BOOKMARK MANAGEMENT

- (NSURL *)currentDiaryURL; // ADDED IN RECIPE 6
- (void)setCurrentDiaryURL:(NSURL *)absoluteURL; // ADDED IN RECIPE 6

- (NSData *)aliasDataFromURL:(NSURL *)fileURL; // ADDED IN RECIPE 6
- (NSURL *)URLFromAliasData:(NSData *)aliasData; // ADDED IN RECIPE 6
- (BOOL)canOpenURL:(NSURL *)absoluteURL; // ADDED IN RECIPE 6

#pragma mark ERROR HANDLING

- (NSError *)diaryDocumentAlreadyOpenError; // ADDED IN RECIPE 6
- (NSError *)incorrectDiaryDocumentErrorForURL:(NSURL *)fileURL; // ADDED IN RECIPE 6

@end
