//
//  DiaryPrintPanelAccessoryController.h
//  Vermont Recipes 2.0.0
//
//  Created by Bill Cheeseman on 2009-11-03.
//  Copyright 2000-2009 Bill Cheeseman. All rights reserved.
//
//  CREATED IN RECIPE 9

#import <Cocoa/Cocoa.h>

extern NSString *VRDefaultDiaryPrintItemsKey; // ADDED IN RECIPE 9
extern NSString *VRDefaultDiaryPrintTagsKey; // ADDED IN RECIPE 9
extern NSString *VRDefaultDiaryPrintHeadersAndFootersKey; // ADDED IN RECIPE 9
extern NSString *VRDefaultDiaryPrintTimestampKey; // ADDED IN RECIPE 9

@interface DiaryPrintPanelAccessoryController : NSViewController <NSPrintPanelAccessorizing> { // EDITED IN RECIPE 9
	IBOutlet NSMatrix *printItemsRadioGroup; // ADDED IN RECIPE 9
	IBOutlet NSButton *printTagsCheckbox; // ADDED IN RECIPE 9
	IBOutlet NSButton *printHeadersAndFootersCheckbox; // ADDED IN RECIPE 9
	IBOutlet NSMatrix *printTimestampRadioGroup; // ADDED IN RECIPE 9
}

#pragma mark FACTORY METHOD

+ (DiaryPrintPanelAccessoryController *)sharedController;  // ADDED IN RECIPE 9

#pragma mark ACCESSOR METHODS

- (NSMatrix *)printItemsRadioGroup; // ADDED IN RECIPE 9
- (NSButton *)printTagsCheckbox; // ADDED IN RECIPE 9
- (NSButton *)printHeadersAndFootersCheckbox; // ADDED IN RECIPE 9
- (NSMatrix *)printTimestampRadioGroup; // ADDED IN RECIPE 9

- (void)setPrintItems:(NSInteger)option; // ADDED IN RECIPE 9
- (NSInteger)printItems; // ADDED IN RECIPE 9

- (void)setPrintTags:(BOOL)flag; // ADDED IN RECIPE 9
- (BOOL)printTags; // ADDED IN RECIPE 9

- (void)setPrintHeadersAndFooters:(BOOL)flag; // ADDED IN RECIPE 9
- (BOOL)printHeadersAndFooters; // ADDED IN RECIPE 9

- (void)setPrintTimestamp:(NSInteger)option; // ADDED IN RECIPE 9
- (NSInteger)printTimestamp; // ADDED IN RECIPE 9

#pragma mark ACTION METHODS

- (IBAction)changePrintItems:(id)sender; // ADDED IN RECIPE 9
- (IBAction)changePrintTags:(id)sender; // ADDED IN RECIPE 9
- (IBAction)changePrintHeadersAndFooters:(id)sender; // ADDED IN RECIPE 9
- (IBAction)changePrintTimestamp:(id)sender; // ADDED IN RECIPE 9

#pragma mark VIEW MANAGEMENT

- (void)updateView; // ADDED IN RECIPE 9

@end
