//
//  VRApplicationController.m
//  Vermont Recipes 2.0.0
//
//  Created by Bill Cheeseman on 2009-07-10.
//  Copyright 2000-2009 Bill Cheeseman. All rights reserved.
//
//  CREATED IN RECIPE 5

#import "VRApplicationController.h"
#import "VRDocumentController.h" // ADDED IN RECIPE 5
#import "DiaryWindowController.h" // ADDED IN RECIPE 5
#import "PreferencesWindowController.h" // ADDED IN RECIPE 10
#import "RecipesWindowController.h" // ADDED IN RECIPE 10
#import "DiaryPrintPanelAccessoryController.h" // ADDED IN RECIPE 10


@implementation VRApplicationController

#pragma mark INITIALIZATION

+ (void)initialize { // ADDED IN RECIPE 9, MODIFIED IN RECIPE 10
	if (self == [VRApplicationController class]) {	
		// Register initial user defaults.
		NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
		NSDictionary *initialUserDefaults = [NSDictionary dictionaryWithObjectsAndKeys:NSStringFromSize(NSMakeSize(1200.0, 800.0)), VRDefaultRecipesWindowStandardSizeKey, NSStringFromSize(NSMakeSize(600.0, 900.0)), VRDefaultDiaryWindowStandardSizeKey, [NSNumber numberWithBool:NO], VRDefaultDiaryPrintTagsKey, [NSNumber numberWithBool:YES], VRDefaultDiaryPrintHeadersAndFootersKey, [NSNumber numberWithInteger:0], VRDefaultDiaryPrintTimestampKey, [NSNumber numberWithDouble:30.0], VRDefaultDiaryAutosaveIntervalKey, nil];
		[defaults registerDefaults:initialUserDefaults];
	}
}

#pragma mark ACTION METHODS

- (IBAction)showReadMe:(id)sender { // ADDED IN RECIPE 5
	NSString *path = [[NSBundle mainBundle] pathForResource:@"Read Me" ofType:@"rtf"];
	if ((path == nil) || ![[NSWorkspace sharedWorkspace] openFile:path]) {
		NSBeep();
	}
}

- (IBAction)findTag:(id)sender { // ADDED IN RECIPE 5
	[[VRDocumentController sharedDocumentController] newDiaryDocument:sender];
	
	NSWindow *keyWindow = [NSApp keyWindow];
	if ([[keyWindow windowController] isKindOfClass:[DiaryWindowController class]]) {
		DiaryWindowController *keyWindowController = [keyWindow windowController];
		[keyWindowController findTag:sender];
	} else {
		NSBeep();
	}
}

- (IBAction)showPreferences:(id)sender { // ADDED IN RECIPE 10
	[[PreferencesWindowController sharedController] showWindow:sender];
}

#pragma mark DELEGATE METHODS

- (void)applicationDidFinishLaunching:(NSNotification *)notification { // ADDED IN RECIPE 7; MODIFIED IN RECIPE 10
	[[VRDocumentController sharedDocumentController] setAutosavingDelay:[[NSUserDefaults standardUserDefaults] doubleForKey:VRDefaultDiaryAutosaveIntervalKey]];
}

@end
