//
//  DiaryEntry.h
//  Vermont Recipes 2.0.0
//
//  Copyright 2000-2010 Bill Cheeseman. All rights reserved.
//
//  CREATED IN RECIPE 12

#import <Cocoa/Cocoa.h>

@class DiaryDocument; // ADDED IN RECIPE 12


@interface DiaryEntry : NSObject {
	NSRange entryRange; // ADDED IN RECIPE 12
	DiaryDocument *diaryDocument; // ADDED IN RECIPE 12
}

#pragma mark INITIALIZATION

- (id)initWithRange:(NSRange)range forDocument:(DiaryDocument *)document; // ADDED IN RECIPE 12

#pragma mark ACCESSOR METHODS

- (NSRange)entryRange; // ADDED IN RECIPE 12

- (DiaryDocument *)diaryDocument; // ADDED IN RECIPE 12

- (void)setName:(NSString *)name; // ADDED IN RECIPE 12
- (NSString *)name; // ADDED IN RECIPE 12

- (void)setDate:(NSDate *)date; // ADDED IN RECIPE 12
- (NSDate *)date; // ADDED IN RECIPE 12

- (void)setTags:(NSArray *)tags; // ADDED IN RECIPE 12
- (NSArray *)tags; // ADDED IN RECIPE 12

- (void)setBodyText:(id)text; // ADDED IN RECIPE 12
- (NSTextStorage *)bodyText; // ADDED IN RECIPE 12

- (void)setEntryText:(id)text; // ADDED IN RECIPE 12
- (NSTextStorage *)entryText; // ADDED IN RECIPE 12

#pragma mark APPLESCRIPT SUPPORT

- (id)handleEncryptCommand:(NSScriptCommand *)command; // ADDED IN RECIPE 12
- (id)handleDecryptCommand:(NSScriptCommand *)command; // ADDED IN RECIPE 12

- (NSRange)bodyTextRange; // ADDED IN RECIPE 12

@end
