//
//  NSScreen+VRScreenAdditions.m
//  Vermont Recipes 2.0.0
//
//  Created by Bill Cheeseman on 2009-10-09.
//  Copyright 2000-2009 Bill Cheeseman. All rights reserved.
//
//  CREATED IN RECIPE 7

#import "NSScreen+VRScreenAdditions.h"


@implementation NSScreen (VRScreenAdditions)

+ (NSScreen *)VR_screenWithLargestVisibleFrame { // ADDED IN RECIPE 7
	// Return the screen having the largest visible frame.
	NSArray *screenArray = [NSScreen screens];
	if ([screenArray count] == 1) return [screenArray objectAtIndex:0]; // same as +mainScreen
	
	// If multiple monitors, get screen with largest visible frame.
	NSScreen *screen = nil;
	CGFloat largestScreenArea = 0.0;
	CGFloat thisScreenArea = 0.0;
	for (NSScreen *thisScreen in screenArray) {
		thisScreenArea = NSWidth([thisScreen visibleFrame]) * NSHeight([thisScreen visibleFrame]);
		if (thisScreenArea > largestScreenArea) {
			screen = thisScreen;
			largestScreenArea = thisScreenArea;
		}
	}
	return screen;
}

@end
