//
//  DiaryPrintView.h
//  Vermont Recipes 2.0.0
//
//  Created by Bill Cheeseman on 2009-11-08.
//  Copyright 2000-2009 Bill Cheeseman. All rights reserved.
//
//  CREATED IN RECIPE 9

#import <Cocoa/Cocoa.h>
#import "DiaryDocument.h" // ADDED IN RECIPE 9

extern NSString *VRDefaultSuppressScaleUpAlertKey; // ADDED IN RECIPE 10

@interface DiaryPrintView : NSView {
	DiaryDocument *currentDocument; // ADDED IN RECIPE 9
	NSDate *currentDate; // ADDED IN RECIPE 9
	NSPrintOperation *currentOperation; // ADDED IN RECIPE 9
	NSTextStorage *textStorage; // ADDED IN RECIPE 9
}

#pragma mark ACCESSOR METHODS

- (void)setCurrentDocument:(DiaryDocument *)document; // ADDED IN RECIPE 9
- (DiaryDocument *)currentDocument; // ADDED IN RECIPE 9

- (void)setCurrentDate:(NSDate *)date; // ADDED IN RECIPE 9
- (NSDate *)currentDate; // ADDED IN RECIPE 9

- (void)setCurrentOperation:(NSPrintOperation *)printOperation; // ADDED IN RECIPE 9
- (NSPrintOperation *)currentOperation; // ADDED IN RECIPE 9

- (void)setTextStorage:(NSTextStorage *)storage; // ADDED IN RECIPE 9
- (NSTextStorage *)textStorage; // ADDED IN RECIPE 9

#pragma mark UTILITY METHODS

- (NSArray *)headerAndFooterTabStops; // ADDED IN RECIPE 9
- (NSTextStorage *)printableContent; // ADDED IN RECIPE 9
- (void)paginateContent:(NSSize)defaultPageSize; // ADDED IN RECIPE 9

#pragma mark ALERTS

- (NSAlert *)alertCannotPrintScaledUp; // ADDED IN RECIPE 9

@end
